function [filtrovane_samply,stredni_f] = banka_filtru(sample)
% 
% Funkce banky filtr pro rozdlen na jednotliv frekvenn psma.
% Vstupem je sampl a vzorkovac kmitoet.
% Vstupem jsou vyfyltrovan sampl a vektor stednch kmitot.
% Banka je zaloena na zlomko oktvovch filtrech. Pomoc promnn o je mon
% nastavit poet filtr na oktvu. Pomoc promnn rad se nastavuje d
% filtr.
% Pro zobrazen prbh banky filtr, nebo pro pehrn filtrovanho samplu
% je mon odkomentovat dan sek kdu.
% 

%% definice promennych
Fs = 48000;
fs = 25;                    % pocatecni stredni frekvence
fs_v = fs;
fh = fs * (2^(1/6));        % poten horn mezn kmitoet
o = 3;                      % poet filtr na oktvu
rad = 2;                    % d filtru
type = 'bandpass';          % typ filtru
i = 1;                      % iterace

%filtrovane_samply = zeros(200000,29);
while fh < Fs/2
    
    %% vpoet parametr filtr
    if i >= 2;
        fs = 2^(1/o)*fs;        % vpoet stednch kmitot
        fs_v = [fs_v fs];       % vektor stednch kmitot
    end
    fd = fs / (2^(1/6));    % vpoet dolnho meznho kmitotu         
    fh = fs * (2^(1/6));    % vpoet hornho meznho kmitotu
    
    
    %% vypocet banky filtru
    if fh < Fs/2
        Wn = [fd/(Fs/2) fh/(Fs/2)];                   % vektor meznch kmitot
        [z,p,k] = butter (rad,Wn,type);           % vpoet filtru
        [b,a] = zp2tf(z,p,k);                         % pevodn nulovch bod a pl na penosovou funkci
        filtrovane_samply(:,i) = filter(b,a,sample);  % filtrace signlu
    
        %% pehrn pro debuging
%        sound (filtrovane_samply (:,i),Fs);
    
        %% vykreslen
%        figure;
%         subplot(3,1,1);
%         plot (sample);                                                   % asov prbh samplu
%         subplot(3,1,2);
%         plot (filtrovane_samply(:,i))                                    % asov prbh vyltrovanho samplu
%         subplot(3,1,3);
%         freqz(b,a,Fs/2,Fs);                                               % penos filtru
% 
%         figure;
%         fft_sample = abs(fft(sample));                                   % spektrum samplu 
%         fft_filter = abs(fft(filtrovane_samply (:,i)));                  % spektrum filtrovanho samplu
%         subplot(2,1,1)
%         plot(fft_sample);
%         subplot(2,1,2)
%         plot(fft_filter);
%           hold on;
%           freqz(b,a,Fs/2,Fs); 
          
        %% iterace
          i = i+1;
    end
    
end
    for j = 1:length(filtrovane_samply(1,:))                               
        stredni_f(j,1) = fs_v(j);                                            % pedn stednch kmitot filtr
    end
end