% 
% Tento soubor je testovac m-file. Analyzuje naten audio soubory a
% rozpoznv v nich dery.
% 
% K rozpoznn je teba pipojit vytrnovan modely analzy hlavnch
% komponent a metody podprnch vektor(PCAModel.mat a SVMModel.mat)
 


%% cistka
clc;
clear all;
close all;


%% definice promnnch
%kontinuln reim 
SegmentOFF =0;    %nahrvka [0]/ jeden sampl [1]                                                        

%% naten klasifikanho a PCA modelu
load('SVMModel.mat');
load('PCAModel.mat');
%% automatick naten souboru
fprintf('Natn soubor...\n');

if exist('cesta')                                                          % Existujeli cesta nate soubor
    [sample, fs] = audioread(cesta);
    info = audioinfo(cesta);
    
end

%% run prochzen 
if ~exist('sample') || isempty(sample)                                     % pokud neexistuje sammpl oteve se dialog pro nateni zvukoveho souboru 
                                            
    [filename, pathname] = uigetfile({'*.wav','Zvukov soubory wav';'*.*',...
        'Vechny soubory'},...
        'Vyber zvukov soubor');
    [sample, fs] = audioread( fullfile( pathname, filename));
            info = audioinfo(fullfile( pathname, filename));
    
end
sample = sample(:,1);                                                      % zmonn samplu

clear pathname;
%% segmentace nahrvky
fprintf('Segmentace sampl...\n');
[WindowID,pocet_oken, SegmentID,pocet_segmentu] = okno(sample, fs, 3500, 0.6, SegmentOFF);        % Segmentace na okna
                                
%% klasifikace
 f = waitbar(0,' ', 'Name', 'Vpoet energe v psmech');                    %natn
clear i;
l=1;
if SegmentOFF == 1                                                          % vypnut kontinulnho reimu
    pocet_segmentu = 1;
    clear SegmentID;
    SegmentID(1,1) = 1;
    SegmentID(1,2) = length(sample);
end
for i = 1:pocet_segmentu
    for j = 1:length(WindowID)
        if  SegmentID(i,1) <= WindowID(j,2)-2000 && WindowID(j,1) < SegmentID(i,1)+2000 % Vber oken ptcch do deru
            [filtrovanySMP] = banka_filtru(sample(WindowID(j,1):WindowID(j,2)));    % Filtrace bankou filtr
            [E] = energie(filtrovanySMP, sample(WindowID(i,1):WindowID(i,2)));      % Vpoet energi v psmech
            [pcaTranformed] = data2pca(E', PCAModel.PCAmu, PCAModel.PCAcoeff);      % PCA okna
            [SVMlabel,NegLoss ,SVMscore,q] = predict(SVMModel,pcaTranformed);       %SVM okna
            SegmentLabels(l) = SVMlabel;                                            % vybran label okna
            SegmentStat(l,:) = q;                                                   %pravdpodobnost pslunosti okna 
            l=l+1;
            
        end
    end
    if exist('SegmentLabels') 
        modulo = mode(SegmentLabels);                                           % vbr dle nejastjcho vskytu
        SegLab(i) = modulo;
        for w = 1:length(SVMModel.Prior)
            procento(w) = mean(SegmentStat(:,w));                               % uloen prmru procenuln pslunosti tdy
        end
        SegStat(i,:) = procento*100;                                            % pepoet na procenta
        waitbar(i/pocet_segmentu,f,sprintf('%d Z %d',i,pocet_segmentu));        % natn
    end
    clear SegmentLabels; 
    l=1;
end
clear j;
clear l;
clear q;
clear w;
clear filtrovanySMP;
clear modulo;
clear pcaTranformed; 
delete(f);
%% vsledky - grafick zobrazn
fprintf('Zpracovn vsledk...\n');
clear i;

for i = 1:pocet_segmentu                                                    % vbr tdy dle procentuln pslunosti                                                    
   [M,index] = max(SegStat(i,:));
   SegStatLab(i) = index;
end
clear ax;
% uitable
fig = uifigure('Name', 'Vsledky','Position',[100 100 1050 680]);
%% tabulka pravdpodobnost pslunosti tdy
pravdeposobnost = uipanel(fig,'Title','(2) Pravdpodobnost pslunosti deru do tdy [%]','Position',[20 100 700 265]);
uit = uitable('Parent',pravdeposobnost,'Position',[0 0 700 250]);
t = array2table(round(SegStat));
uit.Data = t;
uit.ColumnName = {'Snare','Kick','Hi-Hat','Crash','Ride','Snare + Hi-Hat', 'Kick + Hi-Hat'};
uit.RowName = 1:pocet_segmentu;


%% asov prbh samplu
dt = 1/fs;
time = (0 :dt: (length(sample)*dt)-dt);
% Create TabGroup
graf = uipanel(fig,'Title','(1) asov prbh signlu','Position',[20 370 1025 310]);
TabGroup = uitabgroup(graf);
TabGroup.Position = [0 0 1025 250];
% Create Tab

Tab1 = uitab(TabGroup);
Tab1.Title = 'Pravdpodobnost pslunosti';
        % uiaxes
        ax = uiaxes('Parent',Tab1, 'Position',[10 10 1010 200]);
        hold(ax,'on');
        ax.Box = 'on';
        ax.YLim = [-1.1 1];
        plot(ax,sample);
        xlabel(ax,'vzorek [n]');
        ylabel(ax,'relativn amplituda [aj]');
        clear i;
        c = 0;
        for i = 1:pocet_segmentu
            switch SegStatLab(i)                                                        % vype popisek a obarv sek dle klasifikoven tdy
                case 1                                                              % Snare
                    area(ax,[SegmentID(i,1) SegmentID(i,2)], [-1.1 -1.1],'FaceColor',...
                        'r','FaceAlpha',.1,'EdgeAlpha',.1)
                    area(ax,[SegmentID(i,1) SegmentID(i,2)], [1 1],'FaceColor','r',...
                        'FaceAlpha',.1,'EdgeAlpha',.1)
                    TextLabel(i) = {'Snare'}; 
                case 2                                                             % Kick
                    area(ax,[SegmentID(i,1) SegmentID(i,2)], [-1.1 -1.1],'FaceColor',...
                        'g','FaceAlpha',.1,'EdgeAlpha',.1)
                    area(ax,[SegmentID(i,1) SegmentID(i,2)], [1 1],'FaceColor','g',...
                        'FaceAlpha',.1,'EdgeAlpha',.1)
                    TextLabel(i) = {'Kick'}; 
                case 3                                                             % Hi-Hat
                    area(ax,[SegmentID(i,1) SegmentID(i,2)], [-1.1 -1.1],'FaceColor',...
                        'b','FaceAlpha',.1,'EdgeAlpha',.1)
                    area(ax,[SegmentID(i,1) SegmentID(i,2)], [1 1],'FaceColor','b',...
                        'FaceAlpha',.1,'EdgeAlpha',.1)
                    TextLabel(i) = {'Hi-Hat'}; 
                case 4                                                             % Crash
                    area(ax,[SegmentID(i,1) SegmentID(i,2)], [-1.1 -1.1],'FaceColor',...
                        'c','FaceAlpha',.1,'EdgeAlpha',.1)
                    area(ax,[SegmentID(i,1) SegmentID(i,2)], [1 1],'FaceColor','c',...
                        'FaceAlpha',.1,'EdgeAlpha',.1)
                    TextLabel(i) = {'Crash'};
                case 5                                                             % Ride
                    area(ax,[SegmentID(i,1) SegmentID(i,2)], [-1.1 -1.1],'FaceColor',...
                        'm','FaceAlpha',.1,'EdgeAlpha',.1)
                    area(ax,[SegmentID(i,1) SegmentID(i,2)], [1 1],'FaceColor','m',...
                        'FaceAlpha',.1,'EdgeAlpha',.1)
                    TextLabel(i) = {'Ride'};
                case 6                                                            % SN+HH
                    area(ax,[SegmentID(i,1) SegmentID(i,2)], [-1.1 -1.1],'FaceColor',...
                        'y','FaceAlpha',.1,'EdgeAlpha',.1)
                    area(ax,[SegmentID(i,1) SegmentID(i,2)], [1 1],'FaceColor','y',...
                        'FaceAlpha',.1,'EdgeAlpha',.1)
                    TextLabel(i) = {'Snare + Hi-Hat'};
                case 7                                                            % KICK+HH
                    area(ax,[SegmentID(i,1) SegmentID(i,2)], [-1.1 -1.1],'FaceColor',...
                        'k','FaceAlpha',.1,'EdgeAlpha',.1)
                    area(ax,[SegmentID(i,1) SegmentID(i,2)], [1 1],'FaceColor','k',...
                        'FaceAlpha',.1,'EdgeAlpha',.1)
                    TextLabel(i) = {'Kick + Hi-Hat'};
            end    
        end
Tab2 = uitab(TabGroup);
Tab2.Title = 'Vbr podle nejastjho vskytu';
% uiaxes
        ay = uiaxes('Parent',Tab2,'Position',[10 10 1010 200]);
        hold(ay,'on');
        ay.Box = 'on';
        ay.YLim = [-1.1 1];
        plot(ay,sample);
        xlabel(ax,'vzorek [n]');
        ylabel(ax,'relativn amplituda [aj]');
        clear i;
        c = 0;
        for i = 1:pocet_segmentu
            switch SegLab(i)                                                        % vype popisek a obarv sek dle klasifikoven tdy
                case 1                                                              % Snare
                    area(ay,[SegmentID(i,1) SegmentID(i,2)], [-1.1 -1.1],'FaceColor',...
                        'r','FaceAlpha',.1,'EdgeAlpha',.1)
                    area(ay,[SegmentID(i,1) SegmentID(i,2)], [1 1],'FaceColor','r',...
                        'FaceAlpha',.1,'EdgeAlpha',.1)
                    %TextLabel(i) = {'Snare'}; 
                case 2                                                             % Kick
                    area(ay,[SegmentID(i,1) SegmentID(i,2)], [-1.1 -1.1],'FaceColor',...
                        'g','FaceAlpha',.1,'EdgeAlpha',.1)
                    area(ay,[SegmentID(i,1) SegmentID(i,2)], [1 1],'FaceColor','g',...
                        'FaceAlpha',.1,'EdgeAlpha',.1)
                    %TextLabel(i) = {'Kick'}; 
                case 3                                                             % Hi-Hat
                    area(ay,[SegmentID(i,1) SegmentID(i,2)], [-1.1 -1.1],'FaceColor',...
                        'b','FaceAlpha',.1,'EdgeAlpha',.1)
                    area(ay,[SegmentID(i,1) SegmentID(i,2)], [1 1],'FaceColor','b',...
                        'FaceAlpha',.1,'EdgeAlpha',.1)
                    %TextLabel(i) = {'Hi-Hat'}; 
                case 4                                                             % Crash
                    area(ay,[SegmentID(i,1) SegmentID(i,2)], [-1.1 -1.1],'FaceColor',...
                        'c','FaceAlpha',.1,'EdgeAlpha',.1)
                    area(ay,[SegmentID(i,1) SegmentID(i,2)], [1 1],'FaceColor','c',...
                        'FaceAlpha',.1,'EdgeAlpha',.1)
                    %TextLabel(i) = {'Crash'};
                case 5                                                             % Ride
                    area(ay,[SegmentID(i,1) SegmentID(i,2)], [-1.1 -1.1],'FaceColor',...
                        'm','FaceAlpha',.1,'EdgeAlpha',.1)
                    area(ay,[SegmentID(i,1) SegmentID(i,2)], [1 1],'FaceColor','m',...
                        'FaceAlpha',.1,'EdgeAlpha',.1)
                    %TextLabel(i) = {'Ride'};
                case 6                                                            % SN+HH
                    area(ay,[SegmentID(i,1) SegmentID(i,2)], [-1.1 -1.1],'FaceColor',...
                        'y','FaceAlpha',.1,'EdgeAlpha',.1)
                    area(ay,[SegmentID(i,1) SegmentID(i,2)], [1 1],'FaceColor','y',...
                        'FaceAlpha',.1,'EdgeAlpha',.1)
                    %TextLabel(i) = {'Snare + Hi-Hat'};
                case 7                                                            % KICK+HH
                    area(ay,[SegmentID(i,1) SegmentID(i,2)], [-1.1 -1.1],'FaceColor',...
                        'k','FaceAlpha',.1,'EdgeAlpha',.1)
                    area(ay,[SegmentID(i,1) SegmentID(i,2)], [1 1],'FaceColor','k',...
                        'FaceAlpha',.1,'EdgeAlpha',.1)
                    %TextLabel(i) = {'Kick + Hi-Hat'};
            end    
        end
        clear c;
%% legenda nahoe
LegendaSnare = uilabel(graf);
            LegendaSnare.Position = [0 260 60 22];
            LegendaSnare.Text = 'Snare';
            LegendaSnare.HorizontalAlignment = 'center';
            LegendaSnare.BackgroundColor = [1 0.898 0.898];
LegendaKick = uilabel(graf);
            LegendaKick.Position = [63 260 60 22];
            LegendaKick.Text = 'Kick';
            LegendaKick.HorizontalAlignment = 'center';
            LegendaKick.BackgroundColor = [0.898 1 0.898];
LegendaHiHat = uilabel(graf);
            LegendaHiHat.Position = [126 260 85 22];
            LegendaHiHat.Text = 'Hi-Hat (close)';
            LegendaHiHat.HorizontalAlignment = 'center';
            LegendaHiHat.BackgroundColor = [0.898 0.898 1];
LegendaCrash = uilabel(graf);
            LegendaCrash.Position = [214 260 60 22];
            LegendaCrash.Text = 'Crash';
            LegendaCrash.HorizontalAlignment = 'center';
            LegendaCrash.BackgroundColor = [0.898 1 1];
LegendaRide = uilabel(graf);
            LegendaRide.Position = [277 260 60 22];
            LegendaRide.Text = 'Ride';
            LegendaRide.HorizontalAlignment = 'center';
            LegendaRide.BackgroundColor = [1 0.898 1];
LegendaSnHh = uilabel(graf);
            LegendaSnHh.Position = [340 260 120 22];
            LegendaSnHh.Text = 'Snare + Hi-Hat (close)';
            LegendaSnHh.HorizontalAlignment = 'center';
            LegendaSnHh.BackgroundColor = [1 1 0.898];
LegendaSnK = uilabel(graf);
            LegendaSnK.Position = [463 260 120 22];
            LegendaSnK.Text = 'Kick + Hi-Hat (close)';
            LegendaSnK.HorizontalAlignment = 'center';
            LegendaSnK.BackgroundColor = [0.898 0.898 0.898];

FileText = sprintf('Sample: %s',filename);
LegendaFILE = uilabel(graf);
            LegendaFILE.Position = [625 260 300 22];
            LegendaFILE.Text = FileText;
            LegendaFILE.HorizontalAlignment = 'left';

LegendaFILE = uilabel(fig);
            LegendaFILE.Position = [20 60 600 22];
            LegendaFILE.Text = '1 - Zobrazen asovho prbhu vstupn nahrvky s vyznaenmi rozpoznanmi dery.';
            LegendaFILE.HorizontalAlignment = 'left';
            
LegendaFILE = uilabel(fig);
            LegendaFILE.Position = [20 40 600 22];
            LegendaFILE.Text = '2 - Pravdpodobnost pslunosti neznmho deru do jednostlivch td v procentech.';
            LegendaFILE.HorizontalAlignment = 'left';
            
LegendaFILE = uilabel(fig);
            LegendaFILE.Position = [20 20 600 22];
            LegendaFILE.Text = '3 - Piazen tdy a asov znaky der.';
            LegendaFILE.HorizontalAlignment = 'left';
            
%% tabulka - asov znaky labely der
cas = uipanel(fig,'Title','(3) Tidy a asov znaky [vzorek]','Position',[725 100 320 265]);
uit2 = uitable('Parent',cas,'Position',[0 0 290 250]);
Tab2Data = [TextLabel' num2cell(SegmentID)];
uit2.Data = Tab2Data;
uit2.ColumnName = {'Tda','Zatek','Konec'};
uit2.RowName = 1:pocet_segmentu;
