function [trenovaci] = nacteni_souboru();
% Funkce slou k naten soubor trnovac sady. Vol funkce pro filtraci
% bankou filtr a vpoet energi ve frekvennch psmech.
% Matlab vyzve k vbru sloek s jednotlivmi samply.


%% definice promnnch
path = ('C:\');                           

SUM_E = [];                                        


%% vbr sloek
if ~exist('path_sn')
path_sn = uigetdir(path,'Snare');                                        % naten sloky pro Snare
end

if ~exist('path_hi')
path_hi = uigetdir(path,'Hi-Hat');                                       % naten sloky pro Hi-Hat
end

if ~exist('path_kick')
path_kick = uigetdir(path,'Kick');                                         % naten sloky pro Kick
end

% if ~exist('path_ftom')
% path_ftom = uigetdir(path,'Floor tom');                                  % naten sloky pro Floor Tom
% end

if ~exist('path_crash')
path_crash = uigetdir(path,'Crash');                                     % naten sloky pro Crash
end

if ~exist('path_ride')
path_ride = uigetdir(path,'Ride');                                       % naten sloky pro Ride
end

if ~exist('path_SnHh')
path_SnHh = uigetdir(path,'Snare + Hi-Hat');                                       % naten sloky pro Ride
end

if ~exist('path_KickHh')
path_KickHh = uigetdir(path,'Kick + Hi-Hat');                                       % naten sloky pro Ride
end
% if ~exist('path_trash')
% path_trash = uigetdir(path,'Trash');                                   % naten sloky pro Trash
% end
% 
% if ~exist('path_tom1')
% path_tom1 = uigetdir(path,'Tom 1');                                    % naten sloky pro Tom 1
% end
% 
% if ~exist('path_tom2')
% path_tom2 = uigetdir(path,'Tom 2');                                    % naten sloky pro Tom 2
% end


%% naten nzv soubor ve slokch

folder_sn = dir (path_sn);
folder_kick = dir (path_kick);
folder_hi = dir (path_hi);

% folder_ftom = dir (path_ftom);
folder_crash = dir (path_crash);
folder_ride = dir (path_ride);

folder_SnHh = dir (path_SnHh);
folder_KickHh = dir (path_KickHh);
% folder_trash = dir (path_trash);
% folder_tom1 = dir (path_tom1);
% folder_tom2 = dir (path_tom2);

%% naten soubor
f = waitbar(0,'Natn sampl', 'Name', 'Natn sampl SN');            % waitbar   
% SNARE
for i = 1:length(folder_sn)-2                                              % natn sampl pro Snare
    name = char({folder_sn(i+2).name});                                    % prochzen jmen soubor ve sloce
    [sample] = audioread(fullfile( path_sn, name));                        % naten samplu
    sample = sample(:,1);                                                  % zmonn samplu
    [filtrovane_SMP, stredni_f] = banka_filtru(sample);                    % filtrace samplu                              
    [E] = energie(filtrovane_SMP);
    SUM_E = [SUM_E E];
    Snare = i;
    waitbar(i/length(folder_sn),f,sprintf('Natn sampl: %6s %12s',name));
end
delete(f);
 f = waitbar(0,'Natn sampl', 'Name', 'Natn sampl KICK');
% KICK
for i = 1:length(folder_kick)-2                                            % natn sampl pro Kick
    name = char({folder_kick(i+2).name});                                  % prochzen jmen soubor ve sloce
    [sample] = audioread(fullfile( path_kick, name));                      % naten samplu
    sample = sample(:,1);                                                  % zmonn samplu
    [filtrovane_SMP] = banka_filtru(sample);                               % filtrace samplu                              
    [E] = energie(filtrovane_SMP);
    SUM_E = [SUM_E E];
    Kick = i;
    waitbar(i/length(folder_kick),f,sprintf('Natn sampl: %6s %12s',name));
end
delete(f);
% HI-HAT
f = waitbar(0,'Natn sampl', 'Name', 'Natn sampl HI-HAT');
 for i = 1:length(folder_hi)-2                                              % natn sampl pro Hi-hat
     name = char({folder_hi(i+2).name});                                    % prochzen jmen soubor ve sloce
     [sample] = audioread(fullfile( path_hi, name));                        % naten samplu
     sample = sample(:,1);                                                  % zmonn samplu
     [filtrovane_SMP] = banka_filtru(sample);                               % filtrace samplu                              
     [E] = energie(filtrovane_SMP);
     SUM_E = [SUM_E E];
     HiHat = i;
     waitbar(i/length(folder_hi),f,sprintf('Natn sampl: %6s %12s',name));
 end
 delete(f);
 %FLOOR TOM
%  f = waitbar(0,'Natn sampl', 'Name', 'Natn sampl FLOOR TOM');
% for i = 1:length(folder_ftom)-2                                            % natn sampl pro Floor Tom
%     name = char({folder_ftom(i+2).name});                                  % prochzen jmen soubor ve sloce
%     [sample] = audioread(fullfile( path_ftom, name));                      % naten samplu
%     sample = sample(:,1);                                                  % zmonn samplu
%     [filtrovane_SMP] = banka_filtru(sample);                               % filtrace samplu                              
%     [E] = energie(filtrovane_SMP);
%     SUM_E = [SUM_E E];
%     FloorTom = i;
%     waitbar(i/length(folder_ftom),f,sprintf('Natn sampl: %6s %12s',name));
% end
% delete(f);
% CRASH
f = waitbar(0,'Natn sampl', 'Name', 'Natn sampl CRASH');
for i = 1:length(folder_crash)-2                                           % natn sampl pro Crash
    name = char({folder_crash(i+2).name});                                 % prochzen jmen soubor ve sloce
    [sample] = audioread(fullfile( path_crash, name));                      % naten samplu
    sample = sample(:,1);                                                  % zmonn samplu
    [filtrovane_SMP] = banka_filtru(sample);                               % filtrace samplu                              
    [E] = energie(filtrovane_SMP);
    SUM_E = [SUM_E E];
    Crash = i;
    waitbar(i/length(folder_crash),f,sprintf('Natn sampl: %6s %12s',name));
end
delete(f);
% RIDE
f = waitbar(0,'Natn sampl', 'Name', 'Natn sampl RIDE');
for i = 1:length(folder_ride)-2                                            % natn sampl pro Ride
    name = char({folder_ride(i+2).name});                                  % prochzen jmen soubor ve sloce
    [sample] = audioread(fullfile( path_ride, name));                      % naten samplu
    sample = sample(:,1);                                                  % zmonn samplu
    [filtrovane_SMP] = banka_filtru(sample);                               % filtrace samplu                              
    [E] = energie(filtrovane_SMP);
    SUM_E = [SUM_E E];
    Ride = i;
    waitbar(i/length(folder_ride),f,sprintf('Natn sampl: %6s %12s',name));
end
delete(f);
% SNARE A HI-HAT
f = waitbar(0,'Natn sampl', 'Name', 'Natn sampl SNARE + HI-HAT');
for i = 1:length(folder_SnHh)-2                                            % natn sampl pro Ride
    name = char({folder_SnHh(i+2).name});                                  % prochzen jmen soubor ve sloce
    [sample] = audioread(fullfile( path_SnHh, name));                      % naten samplu
    sample = sample(:,1);                                                  % zmonn samplu
    [filtrovane_SMP] = banka_filtru(sample);                               % filtrace samplu                              
    [E] = energie(filtrovane_SMP);
    SUM_E = [SUM_E E];
    SnHh = i;
    waitbar(i/length(folder_ride),f,sprintf('Natn sampl: %6s %12s',name));
end
delete(f);
% KICK A HI-HAT
f = waitbar(0,'Natn sampl', 'Name', 'Natn sampl KICK + HI-HAT');
for i = 1:length(folder_KickHh)-2                                            % natn sampl pro Ride
    name = char({folder_KickHh(i+2).name});                                  % prochzen jmen soubor ve sloce
    [sample] = audioread(fullfile( path_KickHh, name));                      % naten samplu
    sample = sample(:,1);                                                  % zmonn samplu
    [filtrovane_SMP] = banka_filtru(sample);                               % filtrace samplu                              
    [E] = energie(filtrovane_SMP);
    SUM_E = [SUM_E E];
    KickHh = i;
    waitbar(i/length(folder_ride),f,sprintf('Natn sampl: %6s %12s',name));
end
delete(f);
%% vytvoen trnovac struktury
info = table(Snare,Kick,HiHat,Crash,Ride,SnHh,KickHh);
pocet_SMP = Snare + Kick + HiHat + Crash + Ride + SnHh + KickHh;
trenovaci = struct ('E',SUM_E, 'pocet_SMP', pocet_SMP,  'info', ...        % vytvoen trenovac struktury
     info, 'stredni_f',  stredni_f);
end