function [WindowID,WinNum,SegmentID,q] = okno(sample, fs, WinLen, overlap, SegmentOFF)
%
%     Tato funkce rozdl signl do asovc oken a hled zatky a konce der.
%     Vstupnmi parametry jsou zvukov signl, vzorkovac kmitoet, dlka
%     okna (doporueno 3500 sampl) a pesah (doporuen 2/3).
% 
%     Vstupnmi parametry jsou Identifikroty zatk a konc oken,
%     identifiktory zatk a konc der a poet oken.
%

%% definice promnnch
WindowID = 1;                                                               % asov znaky oken
PriznakySum = [0 0];                                                        % pznaky zatk a konc der
WinNum = 1;                                                                 % poet oken
% overlap = 0.6;                                                            
% WinLen=3500;
WinMinus = 1-overlap;                                                       %pepoet pwsahu
if SegmentOFF == 1
    pocet_segmentu = 1;                                                     
    clear SegmentID;
    SegmentID(1,1) = 1;                                                     % asov znaky zatk akonc der
    SegmentID(1,2) = length(sample);
end
%% normalizace hlasitosti


[E] = rms(sample);
if E < 0.4                                                                 % pokud je energie men ne 0.4 (RMS) je signl zeslen
    while E < 0.4
    [E] = rms(sample);
    sample = sample*1.1;
    end
else                                                                        % pokud je energie men ne 0.4 (RMS) je signl zeslaben
    while E > 0.4                                                          
    [E] = rms(sample);
    sample = sample*0.9;
    end
end

%% segmentace plovoucm oknem
for i=1:WinLen*WinMinus:length(sample)
    WindowID (WinNum,1) = i;    
    WindowID (WinNum,2) = i+WinLen;
     if WindowID (WinNum,2) > length(sample)
        WindowID (WinNum,2) = length(sample);
     end
    [priznaky] = tr_detektor(sample(WindowID (WinNum,1):WindowID (WinNum,2)),0,i);    % detekce transient pro hledn der
    PriznakySum= [PriznakySum; priznaky];                                   % vektor pznak zatk a konc transient 
    %priznaky 
    %pause;
    WinNum=WinNum+1;                                                        %poet oken 
end

WinNum = WinNum-1;
WindowID (WinNum,2) = length(sample);
%% oven zatku - pokud je na zatku nahrvky signl silnj ne prahov rove
clear i;
WhileOff=0;
i=1;
SegOn = 0;
while WhileOff == 0
    if PriznakySum(i,1) ~= 0
        WhileOff=1;
        SegOn = 1;
    end
    if PriznakySum(i,2) ~= 0
        WhileOff=1;
    end
    i=i+1;
end

%% hledn der
% Cyklus prohledv pznaky a vynechv nolov hodnoty. Hledal i vce
% Sousedc pznaky prmruje
clear i;
first=1;
p=1;
q=1;
s=1;
t=1;
for i=1:length(PriznakySum)
    if PriznakySum(i,1) ~= 0
        StartMean(p) = PriznakySum(i,1);
        p=p+1;
    else
        if p>1 && first == 1;
            SegmentID(q,1) = mean(StartMean);
            q=q+1;
            first = 0;
        end
        if p>2
           SegmentID(q,1) = mean(StartMean);
            q=q+1;
        end
        StartMean = [];
        p=1;
    end
    
    if PriznakySum(i,2) ~= 0
        StopMean(s) = PriznakySum(i,2);
        s=s+1;
    else
        if s>2
            SegmentID(t,2) = mean(StopMean);
            t=t+1;
        end
        StopMean = [];
        s=1;
    end      
end
q=q-1;
if q < 1
    q = 1;
end
%% oven zatk akonc
% pokud se vyskytne chyba zkrt der jen na okna v zatku deru
clear i;
if SegmentID (q,1) == 0
    SegmentCheck(1,1) = 1;
    for i = 1:q
        if i <= length(SegmentID)-1
            SegmentCheck(i+1,1) = SegmentID (i,1);
        end
        SegmentCheck(i,2) = SegmentID (i,2);
    end
else
    SegmentCheck = SegmentID;
end
%clear SegmentID;
clear i;
OutShift = 0;
InShift = 0;
for i = 1:q
    if i <= q-1    
        if SegmentCheck(i+1,1)  < SegmentCheck(i,2)
            buffer (i,2) = SegmentCheck(i,1);
            OutShift = OutShift + 1
        else
            buffer (i,2) = SegmentCheck(i,2);
        end
    else
       buffer (i,2) = SegmentCheck(i,2);
    end
    if i <= q-1
        if SegmentCheck(i,1) > SegmentCheck(i,2)
            buffer (i,1) = SegmentCheck(i,2);
            InShift = InShift + 1;
        else
            buffer (i,1) = SegmentCheck(i,1);
        end  
    else
       buffer (i,1) = SegmentCheck(i,1);
    end
    
        
end
%% pprava pro vstup
if buffer(i,2) == 0
   buffer (i,2) = SegmentCheck(i,1); 
end
clear SegmentID;
SegmentID = buffer;
end    
